/**
 * 
 */
package sync.smartapp;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author naveenb
 * 
 */
public class SyncServlet extends HttpServlet {

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

	
		doPost(request, response);
	}

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		PrintWriter out = null;
		try {

			
			String dataXML = performProcess(request, response);
			//response.setContentType("text/html");
			out = response.getWriter();

		    out.print(dataXML);
			
			out.close();
		} catch (Exception e) {
			if (out == null) {
				out = response.getWriter();
			 }
				String resXML = "failed:"+e.getMessage();
						
				out.println(resXML);
				out.close();
			}
		   

		

	}

	/**
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
	private String performProcess(HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		String outPutXML = null;
		try {

			String requestData = null;
			ServletInputStream stream = request.getInputStream();

			int length = request.getContentLength();

			int ch;
			ByteArrayOutputStream bStrm = new ByteArrayOutputStream();
			while ((ch = stream.read()) != -1) {
				// Ignore any carriage returns/linefeeds
				if (ch != 10 && ch != 13)
					bStrm.write(ch);
				  
			}

			System.out.println(new String(bStrm.toByteArray()));
			
			requestData = new String(bStrm.toByteArray());
			SyncParser parser = new SyncParser();
			Vector vector = parser.parse(requestData);
			SyncDAO syncDAO = new SyncDAO();
			outPutXML = syncDAO.performProcess(vector);

		} catch (Exception e) {
			e.printStackTrace();
			throw new Exception(e.getMessage());
		}
		return outPutXML;

	}

}
